﻿package com.webdevils {
	import caurina.transitions.Tweener;

	public class Content_Manager {
		private var host_mc;
		private var current_content;

		private var start_values:Object;
		private var open_tween:Object;
		private var exit_tween:Object;

		// Constructor --------------------------------------------------------------------------
		public function Content_Manager( _mc, _open:Object, _exit:Object, _start:Object ) {
			host_mc = _mc;
			open_tween = _open;
			exit_tween = _exit;
			start_values = _start;
			exit_tween.onComplete = remove_content;
		}
		
		// Public methods -----------------------------------------------------------------------
		public function add_content( id = null ) {
			if ( current_content != null ) {
				exit_tween.onCompleteParams = [ current_content ];
				Tweener.addTween( current_content, exit_tween );
			}
			
			if ( id != null ) {
				current_content = new id();
				host_mc.addChild( current_content );
				
				for ( var p in start_values ) {
					current_content[ p ] = start_values[ p ];
				}
				
				Tweener.addTween( current_content, open_tween );
				return current_content;
			} else {
				current_content = null;
			}
		}
		
		public function add_object( _obj = null ) {
			if ( current_content != null ) {
				exit_tween.onCompleteParams = [ current_content ];
				Tweener.addTween( current_content, exit_tween );
			}
			
			if ( _obj != null ) {
				current_content = _obj;
				host_mc.addChild( current_content );
				
				for ( var p in start_values ) {
					current_content[ p ] = start_values[ p ];
				}
				
				Tweener.addTween( current_content, open_tween );
				return current_content;
			} else {
				current_content = null;
			}
		}
		
		public function set_open_tween( _obj:Object ):void {
			open_tween = _obj;
		}
		
		public function set_exit_tween( _obj:Object ):void {
			exit_tween = _obj;
		}
		
		public function set_start_values( _obj:Object ):void {
			start_values = _obj;
		}
		
		public function get_content() {
			return current_content;
		}
		
		// Private methods -----------------------------------------------------------------------
		private function remove_content( _mc ):void {
			host_mc.removeChild( _mc );
		}
	}
}