﻿package com.webdevils{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	public class Scene_3d extends MovieClip {
		private var distance:Number = 400;
		private var ox:Number = 275;
		private var oy:Number = 200;

		private var brightness_start:Number = 0;
		private var brightness_range:Number = 400;
		private var start_brightness:Number = 0;
		private var fade_mult:Number = 50;

		private var obj_array:Array;

		// Constructor ----------------------------------------------------------------
		public function Scene_3d() {// --- Make_3d3
			obj_array = new Array();
			addEventListener( Event.ENTER_FRAME, on_enterframe );
		}// --------------------------------------------------------------------------


		public function add_obj( _obj ):void {
			obj_array.push( _obj );
			addChild( _obj );
		}

		public function remove_obj( _obj ):void {
			for (var p in obj_array) {
				if ( obj_array[p] == _obj ) {
					removeChild( obj_array[p] );
					obj_array.splice( p, 1 );
					break;
				}
			}
		}

		public function clear_scene():void {
			for (var p in obj_array) {
				removeChild( obj_array[p].pop() );
			}
		}

		public function set_brightness_start( _n:Number ):void {
			brightness_start = _n;
		}
		
		public function set_brightness_range( _n:Number ):void {
			brightness_range = _n;
		}
		
		public function set_fade_mult( _n:Number ):void {
			fade_mult = _n;
		}


		private function on_enterframe( e:Event ):void {
			var update_arrange:Boolean = false;
			for (var p in obj_array) {
				var _obj = obj_array[p];
				if ( _obj.update ) {
					update_arrange = true;
					renderPoint( _obj );
				}
			}

			if ( update_arrange ) {
				arrange();
			}
		}



		// Set the origin -------------------------------------------------------------
		public function setOrigin( origin_x:Number, origin_y:Number ):void {
			ox = origin_x;
			oy = origin_y;
		}// --------------------------------------------------------------------------

		// Set the Distance to camera --------------------------------------------------
		public function set_camera_distance( d:Number ):void {
			distance = d;
		}// ---------------------------------------------------------------------------


		// Render object on the stage --------------------------------------------------
		public function renderPoint( _obj ) {
			with ( _obj ) {
				var p = distance / ( distance + myZ );
				x = ( myX * p ) + ox;
				y = ( myY * p ) + oy;
				scaleX = 1 * p;
				scaleY = 1 * p;
				if ( Z < -distance ) {
					visible = false;
				} else {
					visible = true;
					if ( Z > brightness_start ) {
						var bri = ( Z - brightness_start ) / brightness_range * fade_mult;
						transform.colorTransform = new ColorTransform( 1,
						 1,
						 1,
						 1, 
						 bri,
						 bri, 
						 bri, 
						 0 );
					}
				}
				update = false;
			}
		}// -------------------------------------------------------------------------

		public function arrange():void {
			obj_array.sortOn( "myZ", Array.DESCENDING | Array.NUMERIC );

			var i:uint = obj_array.length;
			while ( i-- ) {
				if ( getChildAt( i ) != obj_array[i] ) {
					setChildIndex( obj_array[i], i );
				}
			}
		}
	}
}